// JavaScript Document
// 创建HTML的方法

// 打开网页后要执行的动画
function executeExtend()
{
	if (typeof pageJson.EXTEND == "undefined")
	{
		return;
	}
	setTimeout(delayRun, 200);
}

// 延时运行，开场立即加载动画，骨骼动画，没有加载完成，要等待时间
function delayRun()
{
	// 加场动画
	if (typeof(pageJson.EXTEND.openAnim) != "undefined")
	{
		for (var i=0; i<pageJson.EXTEND.openAnim.length; i++)
		{
			handlerAnim(pageJson.EXTEND.openAnim[i]);
		}
	}
}

/*********************************************************************************/


// 增加页面元素的属性
function bindElementsAttribute()
{
	// 增加Touch层的onMouseDown属性
	var touchlayer = document.getElementById("touchLayer");  // touchLayer	transLayer	txtLayer

	touchlayer.onmousedown = judgeTouchDown;
	touchlayer.onmousemove = judgeTouchMove;
	touchlayer.onmouseup = judgeTouchUp;
	// 增加Span的onClick属性
	var i = 1;
	do
	{
		var str = "p" + i;
 		var span = document.getElementById(str);
		if (span)
		{
			span.setAttribute("onclick", "wordOnClick(this)"); // 增加 onclick属性			
		} else
		{
			return;
		}
		// 如果初始化Word要做改变, 可以实现这个方法
		if (typeof(initWorkCallBack) != "undefined")
		{
			initWorkCallBack(span);
		}
		i += 1;
	} while(1);	
}

/*********************************************************************************/
// 创建Debug显示区域
function createDebugArea(rect)
{
	var debugDiv = document.getElementById("debugLayer");	
	var showdiv = document.createElement("div");
	showdiv.style.position = "absolute";	
	showdiv.style.left = rect[0] + "px";
	showdiv.style.top = rect[1] + "px";
	showdiv.style.width = rect[2] + "px";
	showdiv.style.height = rect[3] + "px";	
	showdiv.style.background = '#'+('00000'+(Math.random()*0x1000000<<0).toString(16)).slice(-6);
	showdiv.style.opacity = 0.5;	
	debugDiv.appendChild(showdiv);
}

// 创建Debug信息显示
function createDebugInfo(info)
{
	var debugLayer = document.getElementById("debugLayer");
	var h1 = document.createElement("h1");
	h1.style.color = "#F00";
	h1.style.position = "absolute";
	h1.style.left = "50px";
	h1.innerHTML = info;
	debugLayer.appendChild(h1);
}

// 显示Debug区域
function entryDebugElement()
{
	if (!debug)
	{
		return;
	}
	createDebug();
}

// 创建Debug
function createDebug()
{
	var arr = pageJson.KLBODY.spriteLayer;
	if (typeof(arr) == "undefined")
	{
		return;
	}
	for (var j=0; j<arr.length; j++)
	{ // 增加Rect
		if (typeof(arr[j].triggerRect) != "undefined")
		{
			createDebugArea(arr[j].triggerRect);
		}
		if (typeof(arr[j].moveEventRect) != "undefined")
		{
			createDebugArea(arr[j].moveEventRect);
		}
	}
	createDebugInfo(pageJson.KLHEAD.info);
}

/*********************************************************************************/
// 插入翻译的方法
function insertTrans(trans)
{
	var context = trans.txt.split("@@");
	var bookTxt = context[0].split("|");
	var bookTrans = context[1].split("|");
	//
	var outterDiv = document.createElement("div");
	outterDiv.align = "center";
	outterDiv.style.position = "absolute";
	outterDiv.style.width = transWidth + "px";
	outterDiv.style.height = transHeight + "px";
	if (typeof trans.isLeft == "undefined")
	{ // 默认在左边显示
		outterDiv.style.left = transMarginOne + "px";
	} else 
	{
		if (trans.isLeft == 0)
		{
			outterDiv.style.left = transMarginTwo + "px";
		} else 
		{
			outterDiv.style.left = transMarginOne + "px";
		}
	}	
	outterDiv.style.top = transMarginTop + "px";
	//
	var transDiv = document.createElement("div");
	transDiv.id = trans.name;
	transDiv.align = "left";
	transDiv.style.padding = "1px";
	transDiv.style.backgroundColor = "#fff";	
	$(transDiv).css("-webkit-border-radius", "10px");
	$(transDiv).css("-moz-border-radius", "10px");
	$(transDiv).css("border-radius", "15px");	
	//
	var innerDiv = document.createElement("div");
	innerDiv.id = trans.name + "in";
	innerDiv.style.margin = "5px";
	innerDiv.style.backgroundColor = "#000";
	innerDiv.style.overflow = "auto";
	innerDiv.style.maxHeight = transHeight + "px";
	innerDiv.style.padding = "20px";
	innerDiv.style.fontFamily = "ITCAvantGardeGothicMedium";
	innerDiv.style.color = "#ffffff";
	$(innerDiv).css("-webkit-border-radius", "10px");	
	$(innerDiv).css("-moz-border-radius", "10px");
	$(innerDiv).css("border-radius", "15px");
	//
	var layer = document.getElementById("transLayer");
	layer.appendChild(outterDiv);
	outterDiv.appendChild(transDiv);
	transDiv.appendChild(innerDiv);
	//
	var values = "";
	for (var i=0; i<bookTxt.length; i++)
	{		 
		var tem1 = "<div style='margin-bottom:10px'><span style='font-size:30px;'>" + bookTxt[i] + "</span><br/>";
		values += tem1;
		var tem2 = "<span style='font-size:25px;'>" + bookTrans[i] + "</span></div>";
		values += tem2;
	}
	innerDiv.innerHTML = values;		
	layer.style.display = "none";	 // 默认隐藏
}

// 判断有没有翻译，有就生成翻译
function judgeTransLayer()
{
	var transElements = pageJson.KLBODY.transLayer;
	if (typeof transElements == "undefined")
	{
		return;
	}
	for (var index=0; index<transElements.length; index++)
	{
		insertTrans(transElements[index]);
	}
}

/*********************************************************************************/
// 插入Text
function insertText(text)
{
	var container = document.getElementById("txtLayer");
	
	var divTxt = document.createElement("div");
	divTxt.id = text.name;
	divTxt.style.position = "absolute";
	divTxt.style.left = text.frame[0] + "px";
	divTxt.style.top = text.frame[1] + "px";
	divTxt.style.fontFamily = text.fontFamily;
	divTxt.style.fontSize = text.fontSize + "px";
	divTxt.style.letterSpacing = text.letterSpacing + "px";	
	divTxt.innerHTML = text.htmlCode;
	
	container.appendChild(divTxt);
}

// 判断有没有Text，有就生成Text
function judgeTextLayer()
{
	var txtElements = pageJson.KLBODY.txtLayer;
	if (typeof txtElements == "undefined")
	{
		return;
	}
	for (var i=0; i<txtElements.length; i++)
	{
		if(typeof(txtElements[i].frame) != 'undefined' && typeof(txtElements[i].frame[2]) != 'undefined' && txtElements[i].frame[2] != 0){
			for(var j=0;j<2;j++){				
				txtElements[i].frame[j]=txtElements[i].frame[j]*scale;	
			}
		}
		insertText(txtElements[i]);
	}	
}

/*********************************************************************************/

// 创建图片元素
function insertSprite(sprite)
{
	if (typeof(sprite.animType) == "undefined")
	{ // 默认动画
		createImg(sprite);
	} else 
	{
		switch(sprite.animType)
		{
			case 0:	// 默认动画
				createImg(sprite);
				break;
			case 1: // 老动画
				createImgAnim(sprite);
				break;
			case 2: // 新动画 createjs				
				createSprite(sprite);
				break;
			case 3: // CSS 动画
				break;
			case 4: // 骨骼动画
				break;
		}
	}	
}

function initAnimAttribute()
{
	var canvas = document.getElementById("drawLayer");
	stage = new createjs.Stage(canvas);
	createjs.Ticker.setFPS(12);								// 设置刷新的帧数				
	createjs.Ticker.addEventListener("tick", stage);		// 刷新监听
}

// 判断精灵层
function judgeSpriteLayer()
{
	var sprites = pageJson.KLBODY.spriteLayer;
	if (typeof(sprites)=='undefined')
	{
		return;
	}
	initAnimAttribute(); // 初始化动画
	for (var i=0; i<sprites.length; i++)
	{
		if(typeof(sprites[i].area) != 'undefined' && typeof(sprites[i].area[4]) != 'undefined' && sprites[i].area[4] != 0){
			for(var j=0;j<4;j++){
				sprites[i].area[j]=sprites[i].area[j]*scale;
			}
		}
		if(typeof(sprites[i].triggerRect) != 'undefined' && typeof(sprites[i].triggerRect[4]) != 'undefined' && sprites[i].triggerRect[4] != 00){
			for(var j=0;j<sprites[i].triggerRect.length;j++){
				sprites[i].triggerRect[j]=sprites[i].triggerRect[j]*scale;	
			}
		}
		if(typeof(sprites[i].moveEventRect) != 'undefined' && typeof(sprites[i].moveEventRect[4]) != 'undefined' && sprites[i].moveEventRect[4] != 00){
			for(var j=0;j<sprites[i].moveEventRect.length;j++){
				sprites[i].moveEventRect[j]=sprites[i].moveEventRect[j]*scale;	
			}
		}
		insertSprite(sprites[i]);
	}
	// 判断有没有骨骼动画
	if (typeof initSkeletalAnim == "function")
	{
		initSkeletalAnim();
	}
	
}
/*********************************************************************************/

// 创建JSON中所有的元素
function createJsonElements()
{
	judgeSpriteLayer();
	judgeTextLayer();
	judgeTransLayer();
}

/*********************************************************************************/
// 创建精灵层
function createSpriteLayer()
{
	var layer = document.createElement("div");
	layer.id = "spriteLayer";
	layer.style.zIndex = 1000;
	layer.style.position = "absolute";
	layer.style.left = "0px";
	layer.style.top = "0px";
	layer.style.width = defWidth + "px";
	layer.style.height = defHeight + "px";
	
	var draw = document.createElement("canvas");
	draw.id = "drawLayer";
	draw.width = defWidth;
	draw.height = defHeight;
	draw.style.position = "absolute";
	draw.style.left = "0px";
	draw.style.right = "0px";
	draw.style.width = defWidth + "px";
	draw.style.height = defHeight + "px";
	draw.style.zIndex = 4000;
		
	layer.appendChild(draw);	
	document.body.appendChild(layer);
}

// 创建Debug层
function createDebugLayer()
{
	var layer = document.createElement("div");
	layer.id = "debugLayer";
	layer.style.zIndex = 5000;
	layer.style.position = "absolute";
	layer.style.left = "0px";
	layer.style.top = "0px";
	layer.style.width = defWidth + "px";
	layer.style.height = defHeight + "px";
	document.body.appendChild(layer);
}

// 创建Touch层
function createTouchLayer()
{	
	// 生成touch层	
	var layer = document.createElement("div");
	layer.id = "touchLayer";
	layer.style.zIndex = 9999;
	layer.style.position = "absolute";
	layer.style.left = "0px";
	layer.style.top = "0px";
	layer.style.width = defWidth + "px";
	layer.style.height = defHeight + "px";
	$(layer).css("-webkit-tap-highlight-color", "transparent");
	
	// 生成文本层
	var txtLayer = document.createElement("div");
	txtLayer.id = "txtLayer";
	txtLayer.style.zIndex = 9999;
	txtLayer.style.position = "absolute";
	txtLayer.style.left = "0px";
	txtLayer.style.top = "0px";
	txtLayer.style.width = defWidth + "px";
	txtLayer.style.height = defHeight + "px";
	txtLayer.style.visibility = "visible";
	
	// 生成翻译层
	var transLayer = document.createElement("div");
	transLayer.id = "transLayer";
	transLayer.style.zIndex = 19999;
	transLayer.style.position = "absolute";
	transLayer.style.left = "0px";
	transLayer.style.top = "0px";
	transLayer.style.width = defWidth + "px";
	transLayer.style.height = defHeight + "px";
	transLayer.style.display = "none";
	//
	layer.appendChild(txtLayer);
	layer.appendChild(transLayer);
	//
	document.body.appendChild(layer);
}

function createPageCodeLayer(){
	var pageCodes = pageJson.KLBODY.pageCodeLayer;
	if (typeof(pageCodes)=='undefined')
	{
		return;
	}
	var content='<div class="pageLayer" style="position:absolute;top:'+pageTop+'px;left:'+pageLeft+'px;z-index:4999;"></div>';
	var content2='<div class="pageLayer" style="position:absolute;top:'+pageTop+'px;left:'+pageRight+'px;z-index:4999;"></div>';
	$('body').append('<div id="pageLayer"></div>');
	$('#pageLayer').append(content);
	$('#pageLayer').append(content2);
	$('.pageLayer').append('<canvas class="can" width="'+pageRadius*2+'" height="'+pageRadius*2+'">')

	var cvx;
	$(".can").each(function(){
		cvx = this.getContext('2d');
		cvx.fillStyle = pageCodes.color;
    	cvx.beginPath();
		cvx.arc(pageRadius,pageRadius,pageRadius,0,Math.PI*2,true);
   	 	cvx.closePath();
    	cvx.fill();
	})
	
	$('.pageLayer').after('<div class="code"></div>')
	$('.code').each(function(index){
		$(this).css({
			"position":"absolute",
			"top":pageTop,
			"z-index":5000,
			"font-family":codeFamily,
			"color":codeColor,
			"width":pageRadius*2,
			"height":pageRadius*2,
			"text-align":"center",
			"line-height":pageRadius*2+'px'
		})
		$(this).text(pageCodes.code[index]);
		if(index==0){
			$(this).css('left',pageLeft);
		}else{
			$(this).css('left',pageRight);	
		}
	})
}
/*********************************************************************************/

// 创建元素的方法
function createBody()
{
	/* 创建所有层 */
	createSpriteLayer();
	createDebugLayer();
	createTouchLayer();
	createPageCodeLayer();
	/* 创建Json元素 */
	createJsonElements();
	/* 创建Debug模块 */
	entryDebugElement();	/* 判断是否显示Debug 最后调用 	*/
	/* add event */	
	bindElementsAttribute();
	/* 执行扩展 */
	executeExtend();
	zoomText();
}
function zoomText(){
	for(var i=1;i<=100;i++){
		var object=$("#text"+i);
		if(typeof object.attr('id')=='undefined')
			break;
		object.css('font-size',parseInt(object.css('font-size'))*0.625+'px');
		object.css('letter-spacing',parseInt(object.css('letter-spacing'))*0.625+'px');
		var child=object.children('p');
		child.each(function(){
			if(typeof this.style.marginTop!='undefined')
				this.style.marginTop=parseInt(this.style.marginTop)*0.625+'px';
			if(typeof this.style.marginLeft!='undefined')
				this.style.marginLeft=parseInt(this.style.marginLeft)*0.625+'px';
		})
	}
}

// body加载js
window.onload = createBody;

