// JavaScript Document
// 相当于公共方法  Dpub

// 停止动画
function stopAnimate()
{
	restoreAnimate2First();
}

// 停止声音任务
function stopAuioTask()
{
	for (var i=0; i<audioTasks.length; i++)
	{
		clearTimeout(audioTasks[i]);
	}
	audioTasks.length = 0;
}


// 显示教学
function showTeaching()
{
	var element = document.getElementById("showpic");
	element.style.visibility = "visible";
}

// 隐藏教学
function hideTeaching()
{
	var element = document.getElementById("showpic");
	element.style.visibility = "hidden";
}

// 显示翻译层
function showTransLayer()
{
	$('#transLayer').toggle();
}

// 隐藏翻译层
function hideTransLayer()
{
	$('#transLayer').toggle();
}

// 显示所有文本
function showAllText()
{
	var transLayer = document.getElementById("txtLayer");	
	transLayer.style.visibility = "visible";	
}

// 隐藏所有文本
function hideAllText()
{
	var transLayer = document.getElementById("txtLayer");
	transLayer.style.visibility = "hidden";
}

// 显示Debug
function showDebug()
{
	var bug = document.getElementById("debugLayer");
	bug.style.visibility = "visible";
}

// 隐藏Debug
function hideDebug()
{
	var bug = document.getElementById("debugLayer");
	bug.style.visibility = "hidden";
}

// 增加字体效果
function addFontEffect(wordID)
{
	if (typeof addFontEffectCallBack == "undefined")
	{
		if (recordWordID != null)
		{
			restoreFontEffect(recordWordID,recordWordColor);
		}
		var element = document.getElementById(wordID);
		if (element == null)
		{
			return;
		}
		var color=element.style.color;
		element.style.color = "#f00";		
	}
	else 
	{
		addFontEffectCallBack(wordID);
	}
	if(typeof playAnimateWithAudio!='undefined'){
		playAnimateWithAudio(wordID);
	}
	recordWordID = wordID;
	recordWordColor = color;
	judgeAnimteByFont(recordWordID);
}

// 根据字体改变播放动画
function playAnimateWithAudio(id){
	if(!isAnimatePlayWhenAudio)
		return;
	var arr=pageJson.KLBODY.spriteLayer;
	for(var i in arr){
		var item=arr[i];
		if(typeof item.relatedPartId=='undefined'){
			continue;
		}
		if(id==item.relatedPartId){
			for(var k in spriteSkeletal){
				var spriteItem=spriteSkeletal[k];
				if(spriteItem.name==item.name){
					runSkeletal(spriteItem,k);
					break;
				}
			}
			break;
		}
	}
}

// 判断单词变色时，是否要播放动画
function judgeAnimteByFont(wordID)
{
	var arrays = pageJson.KLBODY.spriteLayer;
	if (typeof(arrays) == "undefined")
	{
		return;
	}
	for (var i=0; i<arrays.length; i++)
	{
		if (typeof(arrays[i].animByFont) == "undefined")
		{
			continue;
		}
		if (wordID == arrays[i].animByFont)
		{
			executeFunction(arrays[i]);			
			return;
		}
	}	
}

// 还原字体效果
function restoreFontEffect(wordID,color)
{
	if (typeof restoreFontEffectCallBack == "undefined")
	{
		document.getElementById(wordID).style.color = color;
	}
	else
	{
		restoreFontEffectCallBack(wordID);
	}	
}

// 清除字体效果
function clearFontEffect()
{
	restoreFontEffect(recordWordID,recordWordColor);
}

// 播放所有动画
function playAllAnimation()
{
	var arr = pageJson.KLBODY.spriteLayer;
	if (typeof(arr) == "undefined")
	{
		return;
	}
	for (var i=0; i<arr.length; i++)
	{
		if (typeof(arr[i].animType) != "number")
		{
			continue;
		}
		if (arr[i].animType != 0)
		{
			executeFunction(arr[i]);
		}
	}
}

// 设置平台，关于平台信息，请参考variable.js文件
function setPlatform(iPlatform)
{
	platform = iPlatform;
}

// 设置声音效果打开
function audioEffectOn()
{
	audioEffectSwitch = true;
}

// 设置声音效果关闭
function audioEffectOff()
{
	audioEffectSwitch = false;
}

// 改变播放动画时要不要连带文本的效果  打开方法
function animateFontEffectOn()
{
	audioEffectSwitch = true;
}

// 改变播放动画时要不要连带文本的效果  关闭方法
function animateFontEffectOff()
{
	audioEffectSwitch = false;
}

// 停止骨骼动画的方法
function setAnimStop(){
	var sprites=pageJson.KLBODY.spriteLayer;
	var mc;
	for(var k in sprites)
	{
		for(var i in spriteSkeletal){
			if(sprites[k].name==spriteSkeletal[i].name){
				mc=spriteSkeletal[i].mc;
				position=isset(sprites[k].stopPosition)?sprites[k].stopPosition:0;
				mc.gotoAndStop(position);
				pageJson.KLBODY.spriteLayer[k].triggerEnable=0;
			}
		}
	}
}

// 设置read to me时是否播放动画
function readPlayAnimateOn(){
	isAnimatePlayWhenAudio = true;
	var sprites=pageJson.KLBODY.spriteLayer;
	for(var k in sprites){
		if(sprites[k].animType==4){
			sprites[k].triggerEnable=1;
		}
	}
}

function readPlayAnimateOff(){
	isAnimatePlayWhenAudio = false;	
	var sprites=pageJson.KLBODY.spriteLayer;
	for(var k in sprites){
		if(sprites[k].animType==4){
			sprites[k].triggerEnable=0;
		}
	}	
}