// JavaScript Document
// 相当于私有方法

// 加载URL
function loadURL(url)
{
    var iFrame;
    iFrame = document.createElement("iframe");
    iFrame.setAttribute("src", url);
    iFrame.setAttribute("style", "display:none;");
    iFrame.setAttribute("height", "0px");
    iFrame.setAttribute("width", "0px");
    iFrame.setAttribute("frameborder", "0");
    document.body.appendChild(iFrame);
    // 发起请求后这个iFrame就没用了，所以把它从dom上移除掉
    iFrame.parentNode.removeChild(iFrame);
}

// 发送命令的方法
function sendCommand(url)
{
	if (platform == 0)
	{ // 默认没有平台,平台值都大于0
		return;		
	}
	if (platform == 1)
	{ // iPad
		loadURL(url);
	} else if (platform == 2)
	{ // Android
		loadURL(url);
	} else if (platform == 4)
	{ // PC
		document.title = url;
	}
}

// 执行Depub协议
// 多个参数用#号分开
function executeDepubProtocol(funName, params)
{
	if (arguments.length == 0)
	{
		return;
	}
	var url = "depub://";
	for (var i=0; i<arguments.length; i++)
	{
		if (i == 0)
		{ // 第一个参数是方法名称
			url += arguments[i];
		} else 
		{ // 第二个开始是参数，每个参数前面要带#号
			url += ("&" + arguments[i]);
		}
	}
	sendCommand(url);
}

/*********************************************************************************/

// read to me function
function readToMe()
{
	alert("readToMe");
	executeDepubProtocol(DEPUB_PROTOCOL_READTOME);
}

// 文本调用的方法
function wordOnClick(word)
{
	//alert("word click " + word.innerHTML);
	if (typeof wordClickCallBack != "undefined")
	{
		wordClickCallBack(word);
	}
}

function wordClickCallBack(word){
	executeDepubProtocol("playAudioWithWord",word.id,word.innerHTML);	
}


/*********************************************************************************/
// 动画连带着的改变字体
function changeFontEffect(relevantFont)
{
	if (!relevantFont)
	{
		return;
	}
	var changeWordIDs,changeColors,backColors;
	if(relevantFont.constructor==Array){
		changeWordIDs = relevantFont;	
	}else{
		changeWordIDs = relevantFont.wordIDs;
		changeColors = relevantFont.changeColors?relevantFont.changeColors:false;
		backColors = relevantFont.backColors?relevantFont.backColors:false;
	}	
	for (var i=0; i<changeWordIDs.length; i++)
	{
		var element = document.getElementById(changeWordIDs[i]);
		if (element)
		{
			element.style.color = changeColors ? changeColors[i] : "#f00";
		}
	}
	setTimeout(function() { goBackFontEffect(changeWordIDs,backColors) }, 2000);
}

// 还原 动画连带着的字体
function goBackFontEffect(changeWordIDs,backColors)
{
	if (!changeWordIDs)
	{
		return;
	}
	for (var i=0; i<changeWordIDs.length; i++)
	{
		var element = document.getElementById(changeWordIDs[i]);
		if (element)
		{
			element.style.color =backColors ? backColors[i] : "#000";
		}
	}
	changeWordIDs = null;
}

/*********************************************************************************/
//播放音频
function playAudioTask(audio)
{	

	if (!audioEffectSwitch)
	{ // 全局开关
		return;
	}
	if (!audio)
	{ // 没有定义
		return;
	}
	if (audio.length == 0)
	{ // 长度为0
		return;
	}
	stopAuioTask();
	for (var i=0; i<audio.length; i++)
	{
		var delay = 0;
		if (audio[i].audioTimeDelay)
		{
			delay = audio[i].audioTimeDelay;
		}
		if (audio[i].audioPath)
		{
			playAudio(audio[i].audioPath, delay);
		}
	}	
}

// 播放声音
function playAudio(path, delay)
{
	var pp = path;
	var dd = delay;
	var task = setTimeout(function(){ executeDepubProtocol(DEPUB_PROTOCOL_AUDIO_EFFECT, pp); }, dd);
	audioTasks.push(task);
}

/*********************************************************************************/
// 运行骨骼动画
function runSkeletal(skeletal,index)
{
	if(typeof index!='number')
		index=parseInt(index);
	
/*	$('body').append("<div id='showFrame'><input type='text' value=''/></div>")
	$('#showFrame').css({"margin-left":"960px"});
	var sprites=pageJson.KLBODY.spriteLayer;
	//alert(sprites[2].triggerEnable)
	$('#showFrame input').val(sprites[2].triggerEnable);
	setInterval(function(){$('#showFrame input').val(sprites[2].triggerEnable)},100);*/
	//$('#showFrame input').val(skeletal.mc.currentFrame);
	//setInterval(function(){$('#showFrame input').val(mc.currentFrame)},100);
	var mc=skeletal.mc;
	if(mc.currentFrame=='first'){		
		mc.gotoAndPlay(0);
		fontEffectByAnim = true;
		if(typeof mc.endPosition!='undefined'){
			var inter1=setInterval(function(){									
				//$('#showFrame input').val(mc.currentFrame);
				if(mc.timeline.duration-1<=mc.currentFrame){
					mc.gotoAndStop(mc.endPosition);
					mc.set({"currentFrame":mc.timeline.duration+100})
					clearInterval(inter1);
				}
			},100);			
		}
		return;
	}else{
		if(mc.currentFrame>=mc.timeline.duration){
			fontEffectByAnim = true;
			if(empty(mc.onceAnim)){
				if(typeof specialAnim=="function"){
					stage.removeChild(skeletal.mc);
					createjs.MotionGuidePlugin.install();
					//evalStr=("new animate0"+(index+1)+".anim()");
					evalStr=("new lib.anim()");
					var oldMc=mc;
					mc=eval(evalStr);
					if(isset(oldMc.endPosition)) mc.endPosition=oldMc.endPosition;
					mc.onceAnim=isset(oldMc.onceAnim)?oldMc.onceAnim:false;
					stage.addChild(mc);
					spriteSkeletal[index].mc=mc;
				}
				mc.gotoAndPlay(0);				
				if(typeof mc.endPosition!='undefined'){
					var inter1=setInterval(function(){									
						$('#showFrame input').val(mc.currentFrame);
						if(mc.timeline.duration-1<=mc.currentFrame){
							mc.gotoAndStop(mc.endPosition);
							mc.set({"currentFrame":mc.timeline.duration})
							clearInterval(inter1);
						}
					},100);			
				}
			}
			return;
		}else{
			fontEffectByAnim = false;	
		}
	}
	
	if(empty(animPaused)){
		return;	
	}
	if(mc.paused==true){		
		mc.gotoAndPlay();
	}else{
		mc.gotoAndStop();		
	}
	

	//setInterval(function(){$('#showFrame input').val(skeletal.mc.currentFrame)},100);
	//setInterval(function(){$('#showFrame input').val(skeletal.mc.timeline.position)},100);
	//stage.update();
}

function endAnim(mc,interval){
	alert(mc.currentFrame)
/*	if(typeof mc.endPosition=='undefined'){
		return;	
	}
	$('#showFrame input').val(mc.currentFrame);
	if(mc.timeline.duration-1<=mc.currentFrame){
		mc.gotoAndStop(mc.endPosition);
		//clearInterval(interval);
	}*/
}

// 控制动画的播放
function handlerAnim(spriteName)
{ // TODO
	if (!spriteName)
	{
		return;
	}
	var arr = pageJson.KLBODY.spriteLayer;	
	for(var i=0; i<arr.length; i++)
	{
		if (arr[i].name == spriteName)
		{
			executeFunction(arr[i]);
			return;
		}
	}
}

function executeFun(funName)
{
	eval(funName);
}

// 执行方法 || 播放动画
function executeFunction(sprite)
{
	if (typeof(sprite.animRunTime) != "undefined" && sprite.animType!=4)
	{
		sprite.triggerEnable = 0;
		restoreEnable(sprite);
	}
	
	// 设置一次动画属性
	var type = typeof(sprite.onceAnim);
	if (type == "number")
	{
		if (sprite.onceAnim != 0)
		{
			sprite.triggerEnable = 0;
		}
	}	
	if (typeof(sprite.triggerEvent) != "undefined")
	{ // 如果定义了方法，执行定义方法
		var index = sprite.triggerEvent.indexOf("(");
		if (index < 0)
		{ 
			return;
		}
		var funName = sprite.triggerEvent.substring(0, index);
		if (typeof funName == "undefined")
		{
			return;
		}
		executeFun(sprite.triggerEvent);
	} else 
	{ // 没有定义方法，执行精灵动画
		if (spriteSkeletal.length >= 1)
		{
			for (var j=0; j<spriteSkeletal.length; j++)
			{
				if (sprite.name == spriteSkeletal[j].name)
				{
					runSkeletal(spriteSkeletal[j],j);
					//break;
				}
			}		
		}
		if (spriteArray.length >= 1)
		{
			for (var i=0; i<spriteArray.length; i++)
			{
				if (sprite.name == spriteArray[i].name)
				{
					spriteArray[i].sprite.gotoAndPlay("run");
					break;
				}
			}
		}				
	}
	
	// 执行关联的文本
	if (fontEffectByAnim)
	{
		changeFontEffect(sprite.relevantFont);
	}		
	// 播放声音
	playAudioTask(sprite.audio);
}

// 还原动画可以点击
function restoreEnable(sprite)
{
	setTimeout(function() {
		if (sprite.onceAnim)
		{
			return;
		}
		if(!isAnimatePlayWhenAudio){
			return;
		}
		sprite.triggerEnable = 1;
	}, sprite.animRunTime);
}

// 判断Touch是否在Rect内
function judgeRect(x, y, frame)
{
	if (typeof(frame) == "undefined")
	{
		return false;
	}
	if (x > frame[0] && x < frame[0]+ frame[2] 
		&& y > frame[1] && y < frame[1] + frame[3])
	{
		return true;
	}
	return false;
}

// 取得鼠标在网页中的位置
function getMouseCoord(e)
{
	var e = e || window.event;
	// touchX = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
	// touchY = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
	touchX = e.clientX;
	touchY = e.clientY;
}

// 判断点击
function judgeTouchDown(e)
{
	// 得到点击坐标
	getMouseCoord(e);

	var transLayer = document.getElementById("transLayer");
	if (transLayer.style.display != "none")
	{ // 显示翻译层，'#translate').width(),$('#translate').height()];
		$('#transLayer').hide(100);
		return;
	}
		var spriteArr = pageJson.KLBODY.spriteLayer;
	if (typeof(spriteArr) == "undefined")
	{
		return;
	}
	for (var i=0; i<spriteArr.length; i++)
	{
		if (typeof(spriteArr[i].triggerRect) == "undefined")
		{ // 没有区域，判断下一个
			continue;
		}
		
		var type = typeof(spriteArr[i].triggerEnable);
		if (type != "undefined") // 判断能不能触发事件
		{
			if (spriteArr[i].triggerEnable == 0)
			{
				continue;
			}
		}
		var mtype = typeof(spriteArr[i].moveAble);
		if (mtype != "undefined") // 判断能不能移动
		{
			if (spriteArr[i].moveAble != 0)
			{
				continue;
			}
		}		
		var bool = judgeRect(touchX, touchY, spriteArr[i].triggerRect);	
		if (bool) // 判断点击区域
		{
			executeFunction(spriteArr[i]);
			return;
		}
	}
	if (typeof(e.touches) != "undefined")
	{ // Pad
		var mm = judgeMove(e.touches[0].pageX, e.touches[0].pageY);
		if (mm)
		{
			return;
		}		
	} else 
	{ // PC
		var mm = judgeMove(touchX, touchY);
		if (mm)
		{
			return;
		}	
	}
	var ele = e.target || e.srcElement;
	if (!ele)
	{
		return;
	}	
	var index = ele.id.toString().indexOf("p");
	if (index != 0)
	{
		executeDepubProtocol(DEPUB_PROTOCOL_TOUCH_NULL);
	}
}

function judgeMove(touchX, touchY)
{
	var size = pageJson.KLBODY.spriteLayer.length;
	var sprites = pageJson.KLBODY.spriteLayer;
	for (var i=0; i<size; i++)
	{
		var bool = judgeRect(touchX, touchY, sprites[i].triggerRect);
		if (bool)
		{
			moveSpriteObj = sprites[i];
			prevX = touchX;
			prevY = touchY;
			return true;
		}
	}
	return false;
}

function judgeTouchMove(e)
{
	if (!moveSpriteObj)
	{
		return;
	}
	var obj = document.getElementById(moveSpriteObj.name);
	var nowX, nowY;
	
	if (typeof(e.touches) != "undefined")
	{ // Pad
		nowX = e.touches[0].pageX;
		nowY = e.touches[0].pageY;
	} else 
	{ // PC
		nowX = e.clientX;
		nowY = e.clientY;
	}
	var x = nowX - prevX;
	var y = nowY - prevY;
	
	var temX = obj.offsetLeft + x;
	var temY = obj.offsetTop + y;
	//alert(temX + "px||" + temY + "px" + obj.offsetLeft + "||" + obj.offsetTop);
	var temX2 = temX + obj.offsetWidth;
	var temY2 = temY + obj.offsetHeight;
	
	if (temX <= 0 || temX2 >= defWidth)
	{ // 边界超出左边，或者边界超出右边
	}else
	{
		obj.style.left = temX + "px";
		moveSpriteObj.triggerRect[0] = temX;
		
	}
	if (temY <= 0 || temY2 >= defHeight)
	{ // 边界超出头部，或者边界走出底部
	} else
	{
		obj.style.top = temY + "px";
		moveSpriteObj.triggerRect[1] = temY;
	}
	prevX = nowX;
	prevY = nowY;
}

function judgeTouchUp(e)
{
	if (moveSpriteObj == null)
	{
		return;		
	}
	if (typeof(moveSpriteObj.moveEventRect) != "undefined")
	{ // 没有事件Rect
		if (typeof(moveSpriteObj.moveAnimName) != "undefined")
		{			
			var ele = document.getElementById(moveSpriteObj.name);		
			var bool = judgeRect(ele.offsetLeft + ele.offsetWidth / 2,
								 ele.offsetTop + ele.offsetHeight / 2, 
								 moveSpriteObj.moveEventRect);
			if (bool)
			{
				document.getElementById("spriteLayer").removeChild(ele);
				executeFun(moveSpriteObj.moveAnimName);
			}		
		}		
	}
	moveSpriteObj = null;
	prevX = 0;
	prevY = 0;
}

/*********************************************************************************/
// 移动事件
function eventMove(e)
{
	var transLayer = document.getElementById("transLayer");
	if (transLayer.style.display == "none")
	{ // 显示翻译层，不做任何操作
		return;
	}
}

/*********************************************************************************/

// 播放动画
// imgID		图片ID
// pathArr		路径数组
// imgWidth		图片宽
// imgHeight	图片高
// loopNum		循环次数
// fps			一秒类要刷新的张数
function playAnimation(imgID, pathArr, imgWidth, imgHeight, loopNum, fps)
{
	if (typeof(imgID) == "undefined")
	{
		return;
	}	
	var timer, stage;
	var container = Quark.getDOM(imgID);
	var context = new Quark.DOMContext({ canvas:container });
	var actLoopNum = 1;
	var i=1;
	if (document.getElementById(imgID).className=="start")
	{
		document.getElementById(imgID).className="stop";
		stage = new Quark.Stage
		(
			{
				width:imgWidth,
				height:imgHeight,
				context:context,
				update:function()
				{
					if (i >= pathArr.length)
					{
						container.src = pathArr[pathArr.length - 1];
					} else 
					{
						container.src = pathArr[i];
					}					
					if (i >= pathArr.length)
					{
						if(actLoopNum == loopNum)
						{
							document.getElementById(imgID).className="start";
							//timer.stop(); //pause 暂停 resume 恢复 start 开始 stop 停止	
							timer.removeListener(stage);
							if (typeof animateEndCallBack != "undefined")
							{ // 如果动画回调定义了
								animateEndCallBack(imgID);
							}					
						}
						else
						{
							actLoopNum++;
							i = i % pathArr.length;
						} 
					}
					i++;
				}
			}
		);
	}
	else 
	{
		return;
	}
	timer = new Q.Timer(1000/fps);
	timer.addListener(stage);
	timer.start();
}

// 播放精灵动画
function playSpriteAnim(spriteName)
{
	var spriteArr = pageJson.KLBODY.spriteLayer;
	var sprite = null;
	for (var i=0; i<spriteArr.length; i++)
	{
		if (spriteName == spriteArr[i].name)
		{
			sprite = spriteArr[i];
			break;
		}		
	}
	if (sprite == null)
	{
		return;
	}
	if (typeof animJson[spriteName] == "undefined")
	{
		return;
	}
	if (animJson[spriteName].images.length <= 1)
	{
		return;
	}
	var loop = 1;
	if (typeof animJson[spriteName].loop != "undefined")
	{
		loop = animJson[spriteName].loop;
	}
	playAnimation(sprite.imgID, animJson[spriteName].images, 
					sprite.area[2], sprite.area[3],
					loop, 12);
}

// 显示箭头
function showArrow(arrowid)
{
	var arrow = document.getElementById(arrowid);
	arrow.style.opacity = 1;
	if (arrow.style.visibility != "visible")
	{
		arrow.style.visibility = "visible";
	}
	setTimeout(function(){ hideArrow(arrowid) }, 1800);
}

// 隐藏箭头
function hideArrow(arrowid)
{
	$("#" + arrowid).animate({opacity: 0}, 1000);
}

// 还原动画到第一帧
function restoreAnimate2First()
{
	if (spriteSkeletal.length <= 0)
	{
		return;
	}	
	for (var j=0; j<spriteSkeletal.length; j++)
	{
		if (spriteSkeletal[j].sprite)
		{
			stage.removeChild(spriteSkeletal[j].sprite);
		}		
		stage.addChild(spriteSkeletal[j].spriteFirst);
	}	
}
